﻿using System;

namespace Двойственная_математическая_модель
{
    class Program
    {
        static void ShowF(int[] a, int c, string m) // Вывод целевой функции математической модели
        {
            Console.Write("F = ");
            for (int i = 0; i < a.Length; i++) // Цикл для вывода коэффиентов в целевой фунции
            {
                if (i == a.Length - 1)
                {
                    Console.Write(a[i] + m + (i + 1));
                }
                else
                {
                    Console.Write(a[i] + m + (i + 1) + " + ");
                }
            }
            if (c == 0)
            {
                Console.Write(" -> min");
            }
            else
            {
                Console.Write(" -> max");
            }
            Console.WriteLine();
        }
        static void ShowSO(int[,] b, int[] d, int[] e, string m) // Вывод системы ограничений в математической модели
        {
            for (int i = 0; i < b.GetLength(0); i++)
            {
                for (int j = 0; j < b.GetLength(1); j++)
                {
                    if (j == b.GetLength(1) - 1) // Если это последняя переменная в ограничении
                    {
                        if (e[i] == 0)
                        {
                            Console.Write(b[i, j] + m + (j + 1) + " <= " + d[i]);
                        }
                        else if (e[i] == 1)
                        {
                            Console.Write(b[i, j] + m + (j + 1) + " >= " + d[i]);

                        }
                        else
                        {
                            Console.Write(b[i, j] + m + (j + 1) + " = " + d[i]);
                        }
                    }
                    else // Если переменная не последняя
                    {
                        Console.Write(b[i, j] + m + (j + 1) + " + ");
                    }
                }
                Console.WriteLine();
            }
        }
        static void ShowLimitation(int[] a, int[] e, int n, string m) // Вывод граничных условий в математической модели
        {
            for (int i = 0; i < n; i++)
            {
                if (m == "y") // Если это вывод двойсственной ММ
                {
                    if (e[i] == 2) // Если ограничение представленно в виде равенства
                    {
                        if (i == a.Length - 1)
                        {
                            Console.Write(m + (i + 1) + " - любое число");
                        }
                        else
                        {
                            Console.Write(m + (i + 1) + " - любое число, ");
                        }
                    }
                    else // Если ограничение представленно в виде неравенства
                    {
                        if (i == a.Length - 1)
                        {
                            Console.Write(m + (i + 1) + ">=0");
                        }
                        else
                        {
                            Console.Write(m + (i + 1) + ">=0, ");
                        }
                    }
                }
                else // Если вывод исходной ММ
                {
                    if (i == a.Length - 1)
                    {
                        Console.Write(m + (i + 1) + ">=0");
                    }
                    else
                    {
                        Console.Write(m + (i + 1) + ">=0, ");
                    }
                }
            }
            Console.WriteLine();
        }
        static void ShowModele(int[] a, int[,] b, int c, int[] d, int[] e, int n, int[] e1, string m) // Метод для вывода математической модели
        {
            // Вывод целевой функции
            ShowF(a, c, m);
            // Вывод системы ограничений
            ShowSO(b, d, e, m);
            // Вывод граничных условий
            ShowLimitation(a, e1, n, m);
        }
        static void Main(string[] args)
        {
            try
            {
                Console.WriteLine("Обучающая программа по теме: Построение двойственной математической модели к исходной");
                while (true)
                {
                    Console.WriteLine("Выберите действие:\n1 - Посмотреть примеры\n2 - Проверить полученные знания\n3 - Выйти из программы");
                    int v = Convert.ToInt32(Console.ReadLine());
                    if (v == 1)
                    {
                    m3: Console.Clear();
                        Console.WriteLine("Пример построения двойственной задачи ЛП из прямой задачи ЛП");
                        Random random = new Random();
                        int m = random.Next(1, 5); // Количество ограничений
                        int n = random.Next(1, 5); // Количество переменных
                        int[] a = new int[n]; // Массив для хранения значений коэффицентов целевой функции
                        int[,] b = new int[m, n]; // Массив для хранения значений коэфициентов в неравенствах системы ограничений
                        int c = random.Next(2); // Переменная для выбора направления функции (max или min)
                        int[] d = new int[m]; // Массив для хранения правых частей неравенств системы ограничений
                        int[] e = new int[m]; // Массив для выбора знака в неравенставах системе ограничений
                        int[] e1 = new int[n]; // Массив для выбора знака в ограничениях двойственной задачи
                    m1: int k = 0; // Переменная для хранения количества 0 в целевой функции
                        for (int i = 0; i < a.Length; i++) // Цикл для рандомного заполнения коэффициентов целевой функции
                        {
                            a[i] = random.Next(10);
                            if (a[i] == 0) k++;
                        }
                        if (k == a.Length) // Проверка, если все коэффициенты в целевой функции равны 0, то они выбираются вновь
                        {
                            goto m1;
                        }
                        for (int i = 0; i < b.GetLength(0); i++) // Цикл для рандомного заполнения коэффициентов переменных в системе ограничений
                        {
                            for (int j = 0; j < b.GetLength(1); j++)
                            {
                                b[i, j] = random.Next(10);
                            }
                        }
                        for (int i = 0; i < d.Length; i++) // Цикл для рандомного заполнения правых частей неравенств в системе ограничений
                        {
                            d[i] = random.Next(100);
                        }
                        for (int i = 0; i < e.Length; i++) // Цикл для рандомного выбора знака в неравенставах системе ограничений (0 - "<=0", 1 - ">=0", 2 - "=0")
                        {
                            e[i] = random.Next(3);
                        }
                        Console.WriteLine("Дана математическая модель:");
                        ShowModele(a, b, c, d, e, n, e1, "x"); // Вывод математической модели
                        Console.ReadKey();
                        int c1; // Переменная для выбора направления целевой функции двойственной задачи (max или min)
                        if (c == 0) // Если F исходной ММ стремиться к min
                        {
                            Console.WriteLine("Так как целевая функция исходной стремится к min, то целевая функция двойственной задачи будет стремиться к max");
                            c1 = 1;
                        }
                        else // Если F исходной ММ стремиться к max
                        {
                            Console.WriteLine("Так как целевая функция исходной стремится к max, то целевая функция двойственной задачи будет стремиться к min");
                            c1 = 0;
                        }
                        Console.ReadKey();
                        Console.WriteLine("В данной модели будет " + m + " переменных(ая), так как исходная модель содержит " + m + " ограничений(я)");
                        int n1 = m; // Колличество переменных в двойственной задаче
                        int m1 = n; // Количество ограничений в двойственной задаче
                        int[] a1 = d; // Коэффициенты целевой функции в двойственной задаче
                        for (int i = 0; i < a1.Length; i++) // Цикл для смены знаков в случае удовлетворения условия
                        {
                            if (e[i] == 1 && c == 1)
                            {
                                Console.WriteLine("Так как для задачи на максимум ограничения задачи ЛП должны быть либо в виде равенств, либо в виде <=, то необходимо умножить " + (i + 1) + " ограничение на -1");
                                a1[i] = -a1[i];
                            }
                            else if (e[i] == 0 && c == 0)
                            {
                                Console.WriteLine("Так как для задачи на минимум ограничения задачи ЛП должны быть либо в виде равенств, либо в виде >=, то необходимо умножить " + (i + 1) + " ограничение на -1");
                                a1[i] = -a1[i];
                            }
                        }
                        Console.WriteLine("Коэффициенты в целевой функции в двойственной задаче равны правым частям ограничений исходной задачи");
                        Console.WriteLine("Таким образом целевая функция двойственной задачи примет следующий вид: ");
                        ShowF(a1, c1, "y"); // Вывод целевой функции в двойственной задачи
                        Console.ReadKey();
                        Console.WriteLine("Матрица коэффицентов ограничений в двойственной задаче получается транспонирование матрицы коэффициентов ограничений исходной задачи");
                        Console.WriteLine("Правыми честями ограничений двойственной задачи являются коэффициенты целевой функции исходной");
                        int[,] b1 = new int[m1, n1]; // Массив для хранения значений коэфициентов в неравенствах системы ограничений двойственной задачи
                        int[] d1 = a; // Массив для хранения правых частей ограничений в двойственной задаче
                        for (int i = 0; i < b.GetLength(0); i++) // Цикл для транспонирования матрицы коэфициентов ограничений исходной задачи
                        {
                            for (int j = 0; j < b.GetLength(1); j++)
                            {
                                if ((e[i] == 1 && c == 1) || (e[i] == 0 && c == 0))
                                {
                                    b1[j, i] = -b[i, j];
                                }
                                else
                                {
                                    b1[j, i] = b[i, j];
                                }
                            }
                        }
                        for (int i = 0; i < e1.Length; i++) // Цикл для смены знака в ограничениях СО
                        {
                            e1[i] = c;
                        }
                        Console.WriteLine("Таким образом система ограничений в двойственной задачи примет следующий вид: ");
                        ShowSO(b1, d1, e1, "y"); // Вывод системы ограничений в двойственной математической модели
                        Console.ReadKey();
                        Console.WriteLine("Ограничениям неравенствам исходной задачи соответствуют неотрицательные переменные двойственной задачи, а ограничениям равенствам - переменные любого знака и наоборот");
                        Console.ReadKey();
                        Console.WriteLine("Таким образом, двойственная модель для исходной выглядит следующим образом: ");
                        ShowModele(a1, b1, c1, d1, e1, n1, e, "y"); // Вывод двойственной модели
                        Console.WriteLine("\nВыберите действие:\n1 - Посмотреть новый пример\n2 - Вернуться в главное меню");
                        int v1 = Convert.ToInt32(Console.ReadLine());
                        if (v1 == 1)
                        {
                            goto m3;
                        }
                        Console.Clear();
                    }
                    else if (v == 2)
                    {
                    m6: Console.Clear();
                        Random random = new Random();
                        Console.WriteLine("Проверка зананий по теме Построение двойственной математической модели исходной");
                        Console.WriteLine("При проверки знаний будут заданы 7 вопросов. Каждый вопрос имеет разное количество баллов за правильный ответ. Общее количество баллов 10\nРаспределение баллов по оценкам:\n(9-10) - оценка 5 (отлично)\n(7-8) - оценка 4 (хорошо)\n(4-6) - оценка 3 (удовлетворительно)\n(0-3) - оценка 2 (не удовлетворительно)");
                        Console.WriteLine("Нажмите Enter для запуска проверка знаний, а также при переходе к следующему вопросу");
                        Console.ReadKey();
                        Console.Clear();
                        int result = 0; // Переменная которая хранит результат (колличество баллов)
                        int kol_result = 0; // Колличество правильных ответов
                        int m = random.Next(1, 5); // Количество ограничений
                        int n = random.Next(1, 5); // Количество переменных
                        int[] a = new int[n]; // Массив для хранения значений коэффицентов целевой функции
                        int[,] b = new int[m, n]; // Массив для хранения значений коэфициентов в неравенствах системы ограничений
                        int c = random.Next(2); // Переменная для выбора направления функции (max или min)
                        int[] d = new int[m]; // Массив для хранения правых частей неравенств системы ограничений
                        int[] e = new int[m]; // Массив для выбора знака в неравенставах системе ограничений
                        int[] e1 = new int[n]; // Массив для выбора знака в ограничениях двойственной задачи
                    m1: int k = 0; // Переменная для хранения количества 0 в целевой функции
                        for (int i = 0; i < a.Length; i++) // Цикл для рандомного заполнения коэффициентов целевой функции
                        {
                            a[i] = random.Next(10);
                            if (a[i] == 0) k++;
                        }
                        if (k == a.Length) // Проверка, если все коэффициенты в целевой функции равны 0
                        {
                            goto m1;
                        }
                        for (int i = 0; i < b.GetLength(0); i++) // Цикл для рандомного заполнения коэффициентов переменных в системе ограничений
                        {
                            for (int j = 0; j < b.GetLength(1); j++)
                            {
                                b[i, j] = random.Next(10);
                            }
                        }
                        for (int i = 0; i < d.Length; i++) // Цикл для рандомного заполнения правых частей неравенств в системе ограничений
                        {
                            d[i] = random.Next(100);
                        }
                        for (int i = 0; i < e.Length; i++) // Цикл для рандомного выбора знака в неравенставах системе ограничений (0 - "<=0", 1 - ">=0", 2 - "=0")
                        {
                            e[i] = random.Next(3);
                        }
                        Console.WriteLine("Дана математическая модель:");
                        ShowModele(a, b, c, d, e, n, e1, "x"); // Вывод математической модели
                        int n1 = m; // Колличество переменных в двойственной задаче
                        int m1 = n; // Количество ограничений в двойственной задаче
                        int[] a1 = new int[d.Length]; // Коэффициенты целевой функции в двойственной задаче
                        for (int i = 0; i < a1.Length; i++) // Цикл для смены знаков в случае удовлетворения условия
                        {
                            if ((e[i] == 1 && c == 1) || (e[i] == 0 && c == 0))
                            {
                                a1[i] = -d[i];
                            }
                            else
                            {
                                a1[i] = d[i];
                            }
                        }
                        int[,] b1 = new int[m1, n1]; // Массив для хранения значений коэфициентов в неравенствах системы ограничений двойственной задачи
                        int[] d1 = a; // Массив для хранения правых частей ограничений в двойственной задаче
                        for (int i = 0; i < b.GetLength(0); i++) // Цикл для транспонирования матрицы коэфициентов ограничений исходной задачи
                        {
                            for (int j = 0; j < b.GetLength(1); j++)
                            {
                                if ((e[i] == 1 && c == 1) || (e[i] == 0 && c == 0))
                                {
                                    b1[j, i] = -b[i, j];
                                }
                                else
                                {
                                    b1[j, i] = b[i, j];
                                }
                            }
                        }
                        for (int i = 0; i < e1.Length; i++) // Цикл для смены знака в ограничениях СО
                        {
                            e1[i] = c;
                        }
                        Console.WriteLine("Вопрос 1.");
                        Console.Write("Куда будет стремиться целевая функция в двойственной задачи (max или min): ");
                        string str1 = Console.ReadLine();
                        if (c == 0) // Если F стремиться к max
                        {
                            if (str1 == "max")
                            {
                                Console.WriteLine("Ответ верный!");
                                kol_result++;
                                result++;
                            }
                            else
                            {
                                Console.WriteLine("Ответ не верный, целевая функция в двойственной задачи будет стремиться к max");
                            }
                        }
                        else // Если F стремиться к min
                        {
                            if (str1 == "min")
                            {
                                Console.WriteLine("Ответ верный!");
                                kol_result++;
                                result++;
                            }
                            else
                            {
                                Console.WriteLine("Ответ не верный, целевая функция в двойственной задачи будет стремиться к min");
                            }
                        }
                        Console.ReadKey();
                        Console.Clear();
                        Console.WriteLine("Исходная математическая модель:");
                        ShowModele(a, b, c, d, e, n, e1, "x"); // Вывод математической модели
                        Console.WriteLine("Вопрос 2.");
                        Console.Write("Сколько переменных будет содержать двойственная модель: ");
                        int str2 = Convert.ToInt32(Console.ReadLine());
                        if (str2 == m) // Проверка правильности ответа
                        {
                            Console.WriteLine("Ответ верный!");
                            kol_result++;
                            result++;
                        }
                        else
                        {
                            Console.WriteLine("Ответ не верный, двойственная модель будет содержать " + m + " переменных(ую)");
                        }
                        Console.ReadKey();
                        Console.Clear();
                        Console.WriteLine("Исходная математическая модель:");
                        ShowModele(a, b, c, d, e, n, e1, "x"); // Вывод математической модели
                        Console.WriteLine("Вопрос 3.");
                        Console.Write("Какие коэффициенты содержит целевая функция двойственной задачи: ");
                        int[] str3 = new int[m];
                        Console.WriteLine();
                        for (int i = 0; i < str3.Length; i++) // Цикл для ввода ответа пользователя
                        {
                            Console.Write(i + 1 + ") ");
                            str3[i] = Convert.ToInt32(Console.ReadLine());
                        }
                        int o = 0; // Переменная, которая хранит количество верных ответов
                        for (int i = 0; i < str3.Length; i++) // Проверка на правильность
                        {
                            if (a1[i] == str3[i])
                            {
                                o++;
                            }
                        }
                        if (o == a1.Length) // Если все введённые числа верные
                        {
                            Console.WriteLine("Ответ верный!");
                            kol_result++;
                            result += 2;
                        }
                        else
                        {
                            Console.WriteLine("Ответ не верный, правильный ответ: ");
                            for (int i = 0; i < a1.Length; i++) // Вывод правильного результата
                            {
                                Console.Write(a1[i] + " ");
                            }
                        }
                        Console.ReadKey();
                        Console.Clear();
                        Console.WriteLine("Исходная математическая модель:");
                        ShowModele(a, b, c, d, e, n, e1, "x"); // Вывод математической модели
                        Console.WriteLine("Вопрос 4.");
                        Console.Write("Какие коэффициенты ограничений содержит целевая функция двойственной задачи: ");
                        int[,] str4 = new int[m1, n1];
                        Console.WriteLine();
                        for (int i = 0; i < b1.GetLength(0); i++) // Цикл для ввода ответа на вопрос
                        {
                            Console.WriteLine(i + 1 + " ограничение");
                            for (int j = 0; j < b1.GetLength(1); j++)
                            {
                                Console.Write(j + 1 + ") ");
                                str4[i, j] = Convert.ToInt32(Console.ReadLine());
                            }
                        }
                        int o1 = 0; // Переменная, которая хранит количество верных ответов
                        for (int i = 0; i < b1.GetLength(0); i++) // Цикл для проверки на правильность
                        {
                            for (int j = 0; j < b1.GetLength(1); j++)
                            {
                                if (b1[i, j] == str4[i, j])
                                {
                                    o1++;
                                }
                            }
                        }
                        if (o1 == b1.Length) // Если все введённые числа верные
                        {
                            Console.WriteLine("Ответ верный!");
                            kol_result++;
                            result += 2;
                        }
                        else
                        {
                            Console.WriteLine("Ответ не верный, правильный ответ: ");
                            for (int i = 0; i < b1.GetLength(0); i++) // Цикл для вывода правильного результата
                            {
                                for (int j = 0; j < b1.GetLength(1); j++)
                                {
                                    Console.Write(b1[i, j] + " ");
                                }
                                Console.WriteLine();
                            }
                        }
                        Console.ReadKey();
                        Console.Clear();
                        Console.WriteLine("Исходная математическая модель:");
                        ShowModele(a, b, c, d, e, n, e1, "x"); // Вывод математической модели
                        Console.WriteLine("Вопрос 5.");
                        Console.Write("Перечислите правые части ограничений получаемые в двойственной задаче: ");
                        int[] str5 = new int[m1];
                        Console.WriteLine();
                        for (int i = 0; i < d1.Length; i++) // Цикл для ввода ответов
                        {
                            Console.Write(i + 1 + " ограничение: ");
                            str5[i] = Convert.ToInt32(Console.ReadLine());
                        }
                        int o2 = 0; // Переменная, которая хранит количество верных ответов для 5 вопроса
                        for (int i = 0; i < b1.GetLength(0); i++) // Цикл для проверки на правильность
                        {
                            if (d1[i] == str5[i])
                            {
                                o2++;
                            }
                        }
                        if (o2 == d1.Length) // Если все введённые числа верные
                        {
                            Console.WriteLine("Ответ верный!");
                            kol_result++;
                            result += 2;
                        }
                        else
                        {
                            Console.WriteLine("Ответ не верный, правильный ответ: ");
                            for (int i = 0; i < d1.Length; i++) // Цикл для вывода правильного результата
                            {
                                Console.Write(d1[i] + " ");
                            }
                        }
                        Console.ReadKey();
                        Console.Clear();
                        Console.WriteLine("Исходная математическая модель:");
                        ShowModele(a, b, c, d, e, n, e1, "x"); // Вывод математической модели
                        Console.WriteLine("Вопрос 6.");
                        Console.WriteLine("Какое ограничение накладывается на y1?\n1) y1 >= 0\n2) y1 <= 0\n3) y1 = 0 ");
                    m4: int choise = Convert.ToInt32(Console.ReadLine());
                        if (choise != 1 && choise != 2 && choise != 3)
                        {
                            Console.WriteLine("Выбран несуществующей вариант!!! Повторите ввод: ");
                            goto m4;
                        }
                        if (e[0] == 2) // Если первое ограничение представленно в виде равенства
                        {
                            if (choise == 3)
                            {
                                Console.WriteLine("Ответ верный!");
                                kol_result++;
                                result++;
                            }
                            else
                            {
                                Console.WriteLine("Ответ не верный, правильный ответ 3");
                            }
                        }
                        else
                        {
                            if (choise == 1)
                            {
                                Console.WriteLine("Ответ верный!");
                                kol_result++;
                                result++;
                            }
                            else
                            {
                                Console.WriteLine("Ответ не верный, правильный ответ 1");
                            }
                        }
                        Console.ReadKey();
                        Console.Clear();
                        Console.WriteLine("Исходная математическая модель:");
                        ShowModele(a, b, c, d, e, n, e1, "x"); // Вывод математической модели
                        Console.WriteLine("Вопрос 7.");
                        Console.WriteLine("Какой знак имеют ограничения в СО?\n1) >= \n2) <= \n3) = ");
                    m5: int choise1 = Convert.ToInt32(Console.ReadLine());
                        if (choise1 != 1 && choise1 != 2 && choise1 != 3)
                        {
                            Console.WriteLine("Выбран несуществующей вариант!!! Повторите ввод: ");
                            goto m5;
                        }
                        if (c == 1) // Если F стремиться к max
                        {
                            if (choise1 == 1)
                            {
                                Console.WriteLine("Ответ верный!");
                                kol_result++;
                                result++;
                            }
                            else
                            {
                                Console.WriteLine("Ответ не верный, правильный ответ 1 (>=)");
                            }
                        }
                        else if(c == 0) // Если F стремиться к min
                        {
                            if (choise1 == 2)
                            {
                                Console.WriteLine("Ответ верный!");
                                kol_result++;
                                result++;
                            }
                            else
                            {
                                Console.WriteLine("Ответ не верный, правильный ответ 2 (<=)");
                            }
                        }
                        Console.ReadKey();
                        Console.Clear();
                        Console.WriteLine("Полученный результат:");
                        Console.WriteLine("Колличество верных ответов: " + kol_result);
                        if (result >= 9)
                        {
                            Console.WriteLine("Оценка 5 - отлично");
                        }
                        else if (result >= 7 && result < 9)
                        {
                            Console.WriteLine("Оценка 4 - хорошо");
                        }
                        else if (result >= 4 && result < 7)
                        {
                            Console.WriteLine("Оценка 3 - удовлетворительно");
                        }
                        else
                        {
                            Console.WriteLine("Оценка 2 - не удовлетворительно");
                        }
                        Console.WriteLine("\nВыберите действие:\n1 - Заново проверить знания\n2 - Вернуться в главное меню");
                        int v1 = Convert.ToInt32(Console.ReadLine());
                        if (v1 == 1)
                        {
                            goto m6;
                        }
                        Console.Clear();
                    }
                    else
                    {
                        break;
                    }
                }
            }
            catch
            {
                Console.WriteLine("В работе программы возникла ошибка, которая привела к её завершению");
            }
        }
    }
}